Index: utils/astcanary.c
===================================================================
--- utils/astcanary.c	(revision 178204)
+++ utils/astcanary.c	(working copy)
@@ -77,7 +77,7 @@
 	int fd;
 	/* Run at normal priority */
 	setpriority(PRIO_PROCESS, 0, 0);
-	for (;;) {
+	for (;getppid() != 1;) {
 		/* Update the modification times (checked from Asterisk) */
 		if (utime(argv[1], NULL)) {
 			/* Recreate the file if it doesn't exist */
@@ -96,7 +96,7 @@
 		sleep(5);
 	}
 
-	/* Never reached */
+	/* Reached if asterisk (our parent) process dies - it's chldren (we) are inherited by the init process (pid is 1). */
 	return 0;
 }
 
